<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { formatInlineProduct } from '~/helpers/formatInlineProduct';

  const props = defineProps<{ product: Product; showBookmarkShortcut: boolean }>();
  const product = computed(() => props.product);
  const productId = computed(() => props.product.id);
  const { addToCart, loading: loadingAddToCart, countAll } = useAddToCart(product);
  const { isBookmarked, toggleBookmark, loading: loadingBookmark } = useBookmarkItem(productId);
  const { quickViewModalController } = useQuickView();
  const { controlledClient, permissionGranted } = useParticipants();

  const inlineData = computed(() => formatInlineProduct(product.value));
  const handleClick = () => {
    quickViewModalController.open(props.product.id);
  };
</script>

<template>
  <SwInlineProductCard :data="inlineData" @click="handleClick">
    <template #product-meta>
      <div class="flex items-center justify-between">
        <div class="flex gap-1">
          <slot name="line-item-meta">
            <div class="flex gap-1.5">
              <SwBookmarkButton
                v-if="showBookmarkShortcut"
                variant="action"
                class="!px-2"
                :is-bookmarked="isBookmarked"
                :loading="loadingBookmark"
                @click="toggleBookmark"
              />

              <SwButton
                variant="action"
                class="border-transparent bg-gray-50 !px-2 shadow-none"
                :disabled="!controlledClient || !permissionGranted"
                :loading="loadingAddToCart"
                @click="addToCart"
              >
                <template #icon>
                  <span class="i-sw-solid:shopping-cart text-sm" />
                </template>
                <template #default>
                  {{ countAll }}
                </template>
              </SwButton>

              <SwButton
                variant="action"
                class="border-transparent bg-gray-50 shadow-none"
                :disabled="!props.product.sales"
              >
                <span
                  class="i-sw-solid:heart mr-1 text-sm"
                  :class="[props.product.sales && 'text-crimson-500']"
                />
                {{ props.product.sales || 0 }}
              </SwButton>
            </div>
          </slot>
        </div>
      </div>
    </template>
    <template #product-price>
      <ProductPrice :product="product" layout="listing" :show-regulation-price="false" />
    </template>
  </SwInlineProductCard>
</template>
